## easyeffects-8.0.5.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.28)

project(easyeffects VERSION 8.0.5 LANGUAGES CXX C)

set(APPLICATION_DOMAIN "easyeffects")
set(COMPONENT_NAME "easyeffects")
set(ORGANIZATION_NAME "WWMM")
set(ORGANIZATION_DOMAIN "com.github.wwmm")

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(QT_DEFAULT_MAJOR_VERSION 6)
set(QT_MAJOR_VERSION ${QT_DEFAULT_MAJOR_VERSION})

set(QT_QML_GENERATE_QMLLS_INI ON)

option(ENABLE_DEVEL "Whether to use development build mode, with .Devel appended to the application ID. For Flatpak builds, user data for development builds is stored separately from stable builds." OFF)
option(ENABLE_RNNOISE "Whether to use RRNNoise for noise cancellation" ON)
option(ENABLE_LIBCPP_WORKAROUNDS "Enabled Workarounds for systems that use libc++ instead of stdc++" OFF)
option(ENABLE_SANATIZER "Enable the compiler's sanatizer" OFF)

if(ENABLE_DEVEL)
    message(STATUS "Using development build mode with .Devel appended to the application ID.")
    set(APPLICATION_ID "com.github.wwmm.easyeffects.Devel")
    set(APPLICATION_NAME "Easy Effects (Devel)")
else()
    message(STATUS "Using stable build mode with the standard application ID")
    set(APPLICATION_ID "com.github.wwmm.easyeffects")
    set(APPLICATION_NAME "Easy Effects")
endif()

find_package(ECM REQUIRED NO_MODULE)

set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(ECMFindQmlModule)
include(ECMQmlModule)

find_package(Qt${QT_MAJOR_VERSION} REQUIRED NO_MODULE COMPONENTS
    Core
    DBus
    Graphs
    Gui
    Network
    Qml
    Quick
    QuickControls2
    Widgets
    WebEngineQuick
)

find_package(KF${QT_MAJOR_VERSION} REQUIRED COMPONENTS
    ColorScheme
    Config
    ConfigWidgets
    CoreAddons
    I18n
    IconThemes
    Kirigami
    KirigamiAddons
    QQC2DesktopStyle
)

ecm_find_qmlmodule(org.kde.kirigami REQUIRED)

qt_policy(SET QTP0001 NEW)

ki18n_install(po)

find_package(Threads REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(TBB REQUIRED)
find_package(GSL REQUIRED)
# find_package(SoundTouch REQUIRED) # As of SoundTouch 2.4.0 its cmake files are bugged

pkg_check_modules(LIBPIPEWIRE libpipewire-0.3>=1.0.6 IMPORTED_TARGET REQUIRED)
pkg_check_modules(LIBLILV lilv-0>=0.24 IMPORTED_TARGET REQUIRED)
pkg_check_modules(LIBEBUR128 libebur128>=1.2.6 IMPORTED_TARGET REQUIRED)
pkg_check_modules(LIBFFTW3 fftw3 IMPORTED_TARGET REQUIRED)
pkg_check_modules(LIBFFTW3f fftw3f IMPORTED_TARGET REQUIRED)
pkg_check_modules(LIBSPEEXDSP speexdsp IMPORTED_TARGET REQUIRED)
pkg_check_modules(LIBNLOHMANNJSON nlohmann_json IMPORTED_TARGET REQUIRED)
pkg_check_modules(LIBGSL gsl IMPORTED_TARGET REQUIRED)
pkg_check_modules(LIBBS2B libbs2b IMPORTED_TARGET REQUIRED)
pkg_check_modules(LIBSAMPLERATE samplerate IMPORTED_TARGET REQUIRED)
pkg_check_modules(LIBSNDFILE sndfile IMPORTED_TARGET REQUIRED)
pkg_check_modules(LIBRNNOISE rnnoise IMPORTED_TARGET REQUIRED)
pkg_check_modules(LIBSOUNDTOUCH soundtouch IMPORTED_TARGET REQUIRED)
pkg_check_modules(LIBPORTAL libportal IMPORTED_TARGET REQUIRED)
pkg_check_modules(LIBPORTALQT libportal-qt6 IMPORTED_TARGET REQUIRED)
pkg_check_modules(LIBWEBRTC webrtc-audio-processing-2 IMPORTED_TARGET REQUIRED)

file(GLOB KCFG_FILES ${PROJECT_SOURCE_DIR}/src/contents/kcfg/*.kcfg)
file(GLOB KCFGC_FILES ${PROJECT_SOURCE_DIR}/src/contents/kcfg/*.kcfgc)

find_library(LIBZITACONVOLVER NAMES zita-convolver)
find_path(LIBZITACONVOLVER_INCLUDE_DIRS NAMES zita-convolver.h)

add_subdirectory(src)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/CMakeLists.txt ===
configure_file(config.h.in config.h @ONLY)

add_subdirectory(contents)

add_executable(easyeffects)

kde_target_enable_exceptions(easyeffects PRIVATE)

kconfig_add_kcfg_files(easyeffects GENERATE_MOC ${KCFGC_FILES})

# install(FILES ${KCFG_FILES} DESTINATION ${KDE_INSTALL_KCFGDIR})

set_source_files_properties(contents/ui/Validators.qml
    PROPERTIES QT_QML_SINGLETON_TYPE TRUE)

qt_policy(SET QTP0004 NEW)

qt_add_qml_module(easyeffects
    URI ee.ui
    VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
    SOURCES
        presets_list_model.cpp presets_list_model.hpp
    QML_FILES
        contents/ui/AboutPage.qml
        contents/ui/Autogain.qml
        contents/ui/BassEnhancer.qml
        contents/ui/BassLoudness.qml
        contents/ui/BlocklistDialog.qml
        contents/ui/Compressor.qml
        contents/ui/Convolver.qml
        contents/ui/ConvolverImpulseDialog.qml
        contents/ui/Crossfeed.qml
        contents/ui/Crystalizer.qml
        contents/ui/CrystalizerBand.qml
        contents/ui/Deesser.qml
        contents/ui/Delay.qml
        contents/ui/DeepFilterNet.qml
        contents/ui/DelegateClientsList.qml
        contents/ui/DelegateModulesList.qml
        contents/ui/DelegatePluginsList.qml
        contents/ui/DelegateStreamsList.qml
        contents/ui/EchoCanceller.qml
        contents/ui/EeCard.qml
        contents/ui/EeChart.qml
        contents/ui/EeAudioLevel.qml
        contents/ui/EeInputOutputGain.qml
        contents/ui/EeListSectionHeader.qml
        contents/ui/EeProgressBar.qml
        contents/ui/EeSpinBox.qml
        contents/ui/EeSwitch.qml
        contents/ui/Equalizer.qml
        contents/ui/EqualizerBand.qml
        contents/ui/EqualizerBandMenu.qml
        contents/ui/Exciter.qml
        contents/ui/Expander.qml
        contents/ui/Filter.qml
        contents/ui/Gate.qml
        contents/ui/HelpSheet.qml
        contents/ui/LevelMeter.qml
        contents/ui/Limiter.qml
        contents/ui/Loudness.qml
        contents/ui/Maximizer.qml
        contents/ui/MultibandCompressor.qml
        contents/ui/MultibandGate.qml
        contents/ui/Main.qml
        contents/ui/MenuAddPlugins.qml
        contents/ui/PageStreamsEffects.qml
        contents/ui/Pitch.qml
        contents/ui/PipeWirePage.qml
        contents/ui/PluginNotAvailable.qml
        contents/ui/PreferencesSheet.qml
        contents/ui/LspPreMixDialog.qml
        contents/ui/PresetsDialog.qml
        contents/ui/PresetsAutoloadingPage.qml
        contents/ui/PresetsLocalPage.qml
        contents/ui/PresetsCommunityPage.qml
        contents/ui/Reverb.qml
        contents/ui/RNNoise.qml
        contents/ui/ShortcutsSheet.qml
        contents/ui/Speex.qml
        contents/ui/StereoTools.qml
        contents/ui/Validators.qml
        contents/ui/Common.js
)

# The module definitions below are to help the qml linter

qt_add_qml_module(ee_tags_plugin_name
    URI ee.tags.plugin.name
    VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
)

qt_add_qml_module(ee_pipewire
    URI ee.pipewire
    VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
)

qt_add_qml_module(ee_database
    URI ee.database
    VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
)

qt_add_qml_module(ee_presets
    URI ee.presets
    VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
)

qt_add_qml_module(ee_pipeline
    URI ee.pipeline
    VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
)

qt_add_qml_module(ee_autostart
    URI ee.autostart
    VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
)

target_sources(easyeffects PRIVATE
    autogain.cpp
    autogain_preset.cpp
    autostart.cpp
    bass_enhancer.cpp
    bass_enhancer_preset.cpp
    bass_loudness.cpp
    bass_loudness_preset.cpp
    command_line_parser.cpp
    compressor.cpp
    compressor_preset.cpp
    convolver.cpp
    convolver_kernel_fft.cpp
    convolver_kernel_manager.cpp
    convolver_preset.cpp
    convolver_zita.cpp
    crossfeed.cpp
    crossfeed_preset.cpp
    crystalizer.cpp
    crystalizer_preset.cpp
    db_manager.cpp
    delay.cpp
    delay_preset.cpp
    deepfilternet.cpp
    deepfilternet_preset.cpp
    deesser.cpp
    deesser_preset.cpp
    echo_canceller.cpp
    echo_canceller_preset.cpp
    effects_base.cpp
    equalizer.cpp
    equalizer_apo.cpp
    equalizer_preset.cpp
    exciter.cpp
    exciter_preset.cpp
    expander.cpp
    expander_preset.cpp
    filter.cpp
    filter_preset.cpp
    fir_filter_bandpass.cpp
    fir_filter_base.cpp
    fir_filter_highpass.cpp
    fir_filter_lowpass.cpp
    gate.cpp
    gate_preset.cpp
    global_shortcuts.cpp
    kconfig_base_ee.cpp
    ladspa_wrapper.cpp
    level_meter.cpp
    level_meter_preset.cpp
    limiter.cpp
    limiter_preset.cpp
    local_client.cpp
    local_server.cpp
    loudness.cpp
    loudness_preset.cpp
    lv2_ui.cpp
    lv2_wrapper.cpp
    main.cpp
    maximizer.cpp
    maximizer_preset.cpp
    multiband_compressor.cpp
    multiband_compressor_preset.cpp
    multiband_gate.cpp
    multiband_gate_preset.cpp
    output_level.cpp
    pitch.cpp
    pitch_preset.cpp
    plugin_base.cpp
    plugin_preset_base.cpp
    presets_autoload_manager.cpp
    presets_community_manager.cpp
    presets_directory_manager.cpp
    presets_irs_manager.cpp
    presets_rnnoise_manager.cpp
    presets_manager.cpp
    presets_list_model.cpp
    pw_manager.cpp
    pw_client_manager.cpp
    pw_device_manager.cpp
    pw_link_manager.cpp
    pw_metadata_manager.cpp
    pw_module_manager.cpp
    pw_node_manager.cpp
    pw_model_clients.cpp
    pw_model_modules.cpp
    pw_model_nodes.cpp
    resampler.cpp
    reverb.cpp
    reverb_preset.cpp
    rnnoise.cpp
    rnnoise_preset.cpp
    spectrum.cpp
    speex.cpp
    speex_preset.cpp
    stereo_tools.cpp
    stereo_tools_preset.cpp
    stream_input_effects.cpp
    stream_output_effects.cpp
    tags_plugin_name.cpp
    test_signals.cpp
    util.cpp
    resources.qrc
)

target_include_directories(easyeffects SYSTEM PRIVATE
    ${LIBZITACONVOLVER_INCLUDE_DIRS}
)

target_link_libraries(easyeffects PRIVATE
    KF6::ColorScheme
    KF6::ConfigCore
    KF6::ConfigGui
    KF6::CoreAddons
    KF6::I18n
    KF6::IconThemes
    Qt::Core
    Qt::DBus
    Qt::Gui
    Qt::Graphs
    Qt::Network
    Qt::Qml
    Qt::Quick
    Qt::QuickControls2
    Qt::Widgets
    Qt::WebEngineQuick
    TBB::tbb
    GSL::gsl
    GSL::gslcblas
    #SoundTouch::SoundTouch # As of SoundTouch 2.4.0 its cmake files are bugged
    PkgConfig::LIBPIPEWIRE
    PkgConfig::LIBLILV
    PkgConfig::LIBEBUR128
    PkgConfig::LIBFFTW3
    PkgConfig::LIBFFTW3f
    PkgConfig::LIBSPEEXDSP
    PkgConfig::LIBNLOHMANNJSON
    PkgConfig::LIBGSL
    PkgConfig::LIBBS2B
    PkgConfig::LIBSAMPLERATE
    PkgConfig::LIBSNDFILE
    PkgConfig::LIBRNNOISE
    PkgConfig::LIBSOUNDTOUCH
    PkgConfig::LIBPORTAL
    PkgConfig::LIBPORTALQT
    PkgConfig::LIBWEBRTC
    ${LIBZITACONVOLVER}
)

target_compile_definitions(easyeffects PRIVATE QT_NO_KEYWORDS=1)
# target_compile_definitions(easyeffects PRIVATE QT_NO_KEYWORDS=1 QT_QML_DEBUG=1)

if(ENABLE_SANATIZER)
    MESSAGE(STATUS "Enabling the compiler's sanatizer")
    target_compile_options(easyeffects PRIVATE "-fsanitize=address")
    target_link_options(easyeffects PRIVATE "-fsanitize=address")
endif(ENABLE_SANATIZER)

if(ENABLE_RNNOISE)
    MESSAGE(STATUS "Enabling rnnoise")
    target_compile_definitions(easyeffects PRIVATE ENABLE_RNNOISE=1)
endif(ENABLE_RNNOISE)

if(ENABLE_LIBCPP_WORKAROUNDS)
    MESSAGE(STATUS "Enabling workarounds for lib++ systems")
    target_compile_definitions(easyeffects PRIVATE ENABLE_LIBCPP_WORKAROUNDS=1)
endif(ENABLE_LIBCPP_WORKAROUNDS)

install(TARGETS easyeffects ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

=== src/contents/CMakeLists.txt ===
install(FILES 
    icons/${APPLICATION_ID}.svg 
    DESTINATION ${KDE_INSTALL_FULL_DATADIR}/icons/hicolor/scalable/apps
)

install(FILES 
    icons/com.github.wwmm.easyeffects-symbolic.svg 
    DESTINATION ${KDE_INSTALL_FULL_DATADIR}/icons/hicolor/scalable/apps
)

configure_file(com.github.wwmm.easyeffects.metainfo.xml.in
    com.github.wwmm.easyeffects.metainfo.xml.in
)

install(FILES 
    ${CMAKE_CURRENT_BINARY_DIR}/com.github.wwmm.easyeffects.metainfo.xml.in
    DESTINATION ${KDE_INSTALL_METAINFODIR}
    RENAME ${APPLICATION_ID}.metainfo.xml
)

configure_file(com.github.wwmm.easyeffects.desktop.in 
    com.github.wwmm.easyeffects.desktop.in
)

install(FILES 
    ${CMAKE_CURRENT_BINARY_DIR}/com.github.wwmm.easyeffects.desktop.in
    DESTINATION ${KDE_INSTALL_APPDIR}
    RENAME ${APPLICATION_ID}.desktop
)

=== PKGBUILD ===
# This PKGBUILD is intented for our github workflows. For building your custom packages use the file PKGBUILD_AUR

# Contributor: Wellington <wellingtonwallace@gmail.com>
# Maintainer: Upstream https://github.com/wwmm/easyeffects 

pkgname=easyeffects-git
pkgver=pkgvernotupdated
pkgrel=1
pkgdesc='Simple audio effects'
arch=(x86_64)
url='https://github.com/wwmm/easyeffects'
license=('GPL3')
depends=(
  'kcolorscheme' 
  'kirigami' 
  'kirigami-addons'
  'kiconthemes'
  'kconfigwidgets'
  'qqc2-desktop-style' 
  'breeze-icons' 
  'qt6-base'
  'qt6-graphs' 
  'qt6-webengine'
  'pipewire-pulse' 
  'lilv'
  'libsamplerate'
  'libsndfile' 
  'zita-convolver' 
  'libebur128' 
  'rnnoise' 
  'soundtouch' 
  'libbs2b' 
  'nlohmann-json' 
  'tbb' 
  'speexdsp'
  'gsl'
  'libportal-qt6'
  'webrtc-audio-processing'
)
makedepends=('cmake' 'extra-cmake-modules' 'git' 'ninja' 'intltool' 'appstream' 'mold' 'ladspa')
optdepends=('calf: limiter, exciter, bass enhancer and others'
            'lsp-plugins: equalizer, compressor, delay, loudness'
            'zam-plugins: maximizer'
            'mda.lv2: bass loudness'
            'libdeep_filter_ladspa: noise remover'
            'breeze: kde breeze style')
conflicts=(easyeffects)
provides=(easyeffects)
replaces=('pulseeffects')
sha512sums=()

pkgver() {
  description=$(git describe --long | sed 's/^v//;s/\([^-]*-g\)/r\1/;s/-/./g')
  # if in github actions environment
  if test -f "../GITHUB_COMMIT_DESC"; then 
    # remove last commit from git describe output (which may sometimes be a merge commit),
    # and replace it with a human friendly version
    description_short=$(echo "$description" | sed -r 's/(.*)\..*/\1/')
    github_commit_desc_no_hyphen=$(sed 's/-/./g' ../GITHUB_COMMIT_DESC)
    printf "%s" "${description_short}.${github_commit_desc_no_hyphen}"
  else
    printf "%s" "$description"
  fi
}

build() {
  cd ..

  cmake \
    -B build  \
    -S . \
    -G Ninja \
    -DCMAKE_INSTALL_PREFIX:PATH='/usr' \
    -Wno-dev

  cmake --build build
}

package() {
  cd ..
  DESTDIR="${pkgdir}" cmake --install build
}
